﻿//テキストファイルを選択
filename = File.openDialog("修正用テキストファイルを指定してください");
if (!filename) {exit()};
//全レイヤーのロックを解除
layObj = app.activeDocument.layers;
for (a=0; a<layObj.length; a++)
{
layObj[a].locked = false;
}

//行数をカウント→lineCount
if (filename)
{
fileObj = new File(filename);
flag = fileObj.open("r");
if (flag == true)
{
var lineCount = 0;
while (!fileObj.eof)
{
fileObj.readln();
lineCount = lineCount + 1;
}}}

//全レイヤーのグループを解除
layNum=app.activeDocument.layers.length;
//alert(layNum);
for(b=0 ; b<layNum ; b++){
gNum=app.activeDocument.layers[b].groups.length;//文字レイヤーのグループ数
while (gNum>0){
app.activeDocument.layers[b].groups[0].ungroup();
gNum=app.activeDocument.layers[b].groups.length;//文字レイヤーのグループ数を更新
}
}

var pageObjU = app.activeDocument.pages;
for (var i=0; i<pageObjU.length; i++){
   for (var j=pageObjU[i].pageItems.length-1; j>=0; j--){
		if(pageObjU[i].pageItems[j].name == ""){
try{
pageObjU[i].pageItems[j].contentType = ContentType.textType;
}catch (e) {}
            }
	}
}

//データのテキストフレーム（B-1）のレイヤー名（tfName）を取得
tfName=app.documents[0].pageItems.itemByName("B-1" ).itemLayer.name;

//グラフの扇形（S-1）のレイヤー名（tfName）を取得
gphName=app.documents[0].pageItems.itemByName("S-1" ).itemLayer.name;

//スウォッチ名を配列に（取り出しはswArray[]）
sw=1;
swArray=[app.documents[0].pageItems.itemByName("S-"+ sw )];    //配列
while ( app.documents[0].pageItems.itemByName("B-"+ sw ).isValid ) { //データテキストフレームでカウント
swArray.push(app.documents[0].pageItems.itemByName("S-"+ sw ).fillColor.name);    //配列に追加
sw++ //1増やして繰り返し
}

//S-remのスウォッチ名を取得
etc=app.activeDocument.pageItems.itemByName("S-rem");
sRemColor=etc.fillColor.name;

//データ用テキストフレームをすべて空にする
c=1;
while ( app.documents[0].pageItems.itemByName("B-"+ c ).isValid ) {
    app.documents[0].pageItems.itemByName("B-"+ c ).contents="";
    c++
}
c=1;
while ( app.documents[0].pageItems.itemByName("A-"+ c ).isValid ) {
    app.documents[0].pageItems.itemByName("A-"+ c ).contents="";
    c++
}

//円グラフの扇形をグループ化→座標を取得→削除
d=1;    //1からスタート
gph=[app.documents[0].pageItems.itemByName("S-"+ d )];    //配列
while ( app.documents[0].pageItems.itemByName("S-"+ d ).isValid ) { //存在する間は繰り返す
gph.push(app.documents[0].pageItems.itemByName("S-"+ d ));    //配列に追加
d++ //1増やして繰り返し
}
if(app.documents[0].pageItems.itemByName("S-rem").isValid){ //余りの扇形が存在したら
gph.push(app.documents[0].pageItems.itemByName("S-rem")); //これも配列に追加
}
grp=app.documents[0].groups.add(gph);  //配列に含まれるpageItemをグループ化
//四角形の座標
y1r=grp.visibleBounds[0]-10;
x1r=(grp.visibleBounds[1]+grp.visibleBounds[3])/2;
y2r=grp.visibleBounds[2]+10;
x2r=grp.visibleBounds[3]+10;
//円の座標
y1o=grp.visibleBounds[0];
x1o=grp.visibleBounds[1];
y2o=grp.visibleBounds[2];
x2o=grp.visibleBounds[3];

grp.remove();

//行数をカウント→lineCount
if (filename)
{
fileObj = new File(filename);
flag = fileObj.open("r");
if (flag == true)
{
var lineCount = 0;
while (!fileObj.eof)
{
fileObj.readln();
lineCount = lineCount + 1;
}}}

var lineArr = new Array();
fileObj.open("r"); // 読み込みモード
var ruiseki =0;//累積数値
var gCount =1;//行目：1行目からスタート

for(var ln=1 ; ln<=lineCount ; ln++)
{
if( app.documents[0].pageItems.itemByName("A-"+ln).isValid){
var koumoku= fileObj.readln();
	koumoku1 = koumoku.replace(/(.+)+\t+(.+)/,'$1');
	koumoku2 = koumoku.replace(/(.+)+\t+(.+)/,'$2');
graph(koumoku1,koumoku2);

doc = app.documents[0];

txtObjA = app.documents[0].pageItems.itemByName("A-"+ln);
txtObjA.contents = koumoku1 ;

txtObjB = app.documents[0].pageItems.itemByName("B-"+ln);
txtObjB.contents = koumoku2 +"%";

//txtObjBより必要な座標を抽出
yt=txtObjB.visibleBounds[2]+10; //新しい上辺
xt=txtObjB.visibleBounds[1];    //左辺
xt2=txtObjB.visibleBounds[3];   //右辺

//alert(ln);
ln3=ln;
}
}
//alert(ln3);

for(var ln2=ln3 ; ln2<=lineCount-1 ; ln2++){
//    alert(ln2);
  
    var koumoku= fileObj.readln();
	koumoku1 = koumoku.replace(/(.+)+\t+(.+)/,'$1');
	koumoku2 = koumoku.replace(/(.+)+\t+(.+)/,'$2');
    ln=ln2+1;
graph(koumoku1,koumoku2);

    txtObjA = doc.textFrames.add();

    txtObjA.visibleBounds = [yt,xt,yt+4,xt2];//上辺, 左辺, 下辺, 右辺
    txtObjA.contentType = ContentType.textType;
    txtObjA.contents = koumoku1 ;
    txtObjA.paragraphs[0].appliedParagraphStyle=app.documents[0].paragraphStyleGroups.itemByName("graph").paragraphStyles.itemByName("Index");
    txtObjA.move(app.documents[0].layers.itemByName(tfName));
    txtObjA.name="A-"+ln;

    txtObjB = doc.textFrames.add();
    txtObjB.visibleBounds = [yt+4,xt,yt+8,xt2];//上辺, 左辺, 下辺, 右辺
    txtObjB.contentType = ContentType.textType;
    txtObjB.contents = koumoku2+"%";
    txtObjB.paragraphs[0].appliedParagraphStyle=app.documents[0].paragraphStyleGroups.itemByName("graph").paragraphStyles.itemByName("value");
    txtObjB.move(app.documents[0].layers.itemByName(tfName));
    txtObjB.name="B-"+ln;
    
yt=yt+10; 
    
    }

fileObj.close();

//…………………………………………………………………………………………………………

//関数の設定
function graph(a,b){
var perNum=Number(b);
//……………………………………………………
//alert(lineCount+"行のうちの"+gCount+"行目"+"\r内容："+a+"\r直前までのパーセンテージ："+ruiseki+"\rこの項目のパーセンテージ："+perNum);
//……………………………………………………
var i=gCount; //今回の回数：1から

var basePer = ruiseki; //ここまでの累積パーセント
var nowPer = perNum; //今回のパーセント

if(i==1){    //1行目のみ

//nowRectの作図
nowRect1 = app.activeDocument.rectangles.add();//長方形1
nowRect1.geometricBounds = [y1r,x1r,y2r,x2r];//[y1,x1,y2,x2];
nowRect1.move(app.documents[0].layers.itemByName(gphName));
nowRect1.fillColor="None";
nowRect1.strokeColor="None";

nowRect2 = app.activeDocument.rectangles.add();//長方形2
nowRect2.geometricBounds = [y1r,x1r,y2r,x2r]//[y1,x1,y2,x2]の順
nowRect2.move(app.documents[0].layers.itemByName(gphName));
nowRect2.fillColor="None";
nowRect2.strokeColor="None";

if(nowPer<50){
    var nowDig = -360*nowPer/100;　//回転角度
    var my_matrix = app.transformationMatrices.add({counterclockwiseRotationAngle:nowDig});
    nowRect2.transform (CoordinateSpaces.PASTEBOARD_COORDINATES, AnchorPoint.LEFT_CENTER_ANCHOR, my_matrix);
    app.activeDocument.layers.itemByName(gphName).pageItems[0].subtractPath( app.activeDocument.layers.itemByName(gphName).pageItems[1]); //前面オブジェクトで型抜き
}else{
    var nowDig = -360*(nowPer-50)/100;　//ここまでと今回の回転角度の合計−180度（50%）
    var my_matrix = app.transformationMatrices.add({counterclockwiseRotationAngle:nowDig});
    nowRect2.transform (CoordinateSpaces.PASTEBOARD_COORDINATES, AnchorPoint.LEFT_CENTER_ANCHOR, my_matrix);
    app.activeDocument.layers.itemByName(gphName).pageItems[0].addPath( app.activeDocument.layers.itemByName(gphName).pageItems[1]); //結合
}

myOval = app.activeDocument.ovals.add();//楕円
myOval.geometricBounds = [y1o,x1o,y2o,x2o];//[y1,x1,y2,x2]の順
myOval.move(app.documents[0].layers.itemByName(gphName));
myOval.strokeWeight =0;
myOval.fillColor=app.documents[0].swatches.item(swArray[ln]);

Sct=app.activeDocument.layers.itemByName(gphName).pageItems[1].intersectPath( app.activeDocument.layers.itemByName(gphName).pageItems[0]); //交差
Sct.name="S-"+ln;
Sct.sendToBack();
}
else{
//baseRectの作図
baseRect1 = app.activeDocument.rectangles.add();//長方形1
baseRect1.geometricBounds = [y1r,x1r,y2r,x2r];//[y1,x1,y2,x2]の順
baseRect1.move(app.documents[0].layers.itemByName(gphName));
baseRect1.fillColor="None";
baseRect1.strokeColor="None";

baseRect2 = app.activeDocument.rectangles.add();//長方形2
baseRect2.geometricBounds = [y1r,x1r,y2r,x2r];//[y1,x1,y2,x2]の順
baseRect2.move(app.documents[0].layers.itemByName(gphName));
baseRect2.fillColor="None";
baseRect2.strokeColor="None";

if(basePer<50){
    var baseDig = -360*basePer/100;　//ここまでの回転角度
    var my_matrix = app.transformationMatrices.add({counterclockwiseRotationAngle:baseDig});
    baseRect2.transform (CoordinateSpaces.PASTEBOARD_COORDINATES, AnchorPoint.LEFT_CENTER_ANCHOR, my_matrix);
    app.activeDocument.layers.itemByName(gphName).pageItems[i-1].subtractPath( app.activeDocument.layers.itemByName(gphName).pageItems[i]); //前面オブジェクトで型抜き
    }else{
    var baseDig = -360*(basePer-50)/100;　//ここまでの回転角度−180度（50%）
    var my_matrix = app.transformationMatrices.add({counterclockwiseRotationAngle:baseDig});
    baseRect2.transform (CoordinateSpaces.PASTEBOARD_COORDINATES, AnchorPoint.LEFT_CENTER_ANCHOR, my_matrix);
    app.activeDocument.layers.itemByName(gphName).pageItems[i-1].addPath( app.activeDocument.layers.itemByName(gphName).pageItems[i]); //結合
}

//nowRectの作図
nowRect1 = app.activeDocument.rectangles.add();//長方形1
nowRect1.geometricBounds = [y1r,x1r,y2r,x2r];//[y1,x1,y2,x2];//[y1,x1,y2,x2]の順
nowRect1.move(app.documents[0].layers.itemByName(gphName)); 
nowRect1.fillColor="None";
nowRect1.strokeColor="None";

nowRect2 = app.activeDocument.rectangles.add();//長方形2
nowRect2.geometricBounds = [y1r,x1r,y2r,x2r]//[y1,x1,y2,x2]の順
nowRect2.move(app.documents[0].layers.itemByName(gphName));
nowRect2.fillColor="None";
nowRect2.strokeColor="None";

var nowPer2 = basePer+nowPer; //ここまでと今回のパーセントの合計

if(nowPer2<50){
    var nowDig = -360*nowPer2/100;　//ここまでと今回の回転角度の合計
    var my_matrix = app.transformationMatrices.add({counterclockwiseRotationAngle:nowDig});
    nowRect2.transform (CoordinateSpaces.PASTEBOARD_COORDINATES, AnchorPoint.LEFT_CENTER_ANCHOR, my_matrix);
    app.activeDocument.layers.itemByName(gphName).pageItems[i-1].subtractPath( app.activeDocument.layers.itemByName(gphName).pageItems[i]); //前面オブジェクトで型抜き
}else{
    var nowDig = -360*(nowPer2-50)/100;　//ここまでと今回の回転角度の合計−180度（50%）
    var my_matrix = app.transformationMatrices.add({counterclockwiseRotationAngle:nowDig});
    nowRect2.transform (CoordinateSpaces.PASTEBOARD_COORDINATES, AnchorPoint.LEFT_CENTER_ANCHOR, my_matrix);
    app.activeDocument.layers.itemByName(gphName).pageItems[i-1].addPath( app.activeDocument.layers.itemByName(gphName).pageItems[i]); //結合
}

//差の生成
app.activeDocument.layers.itemByName(gphName).pageItems[i].minusBack( app.activeDocument.layers.itemByName(gphName).pageItems[i-1]); //背面オブジェクトで型抜き

myOval = app.activeDocument.ovals.add();//楕円
myOval.geometricBounds = [y1o,x1o,y2o,x2o];//[y1,x1,y2,x2]の順
myOval.move(app.documents[0].layers.itemByName(gphName));
myOval.strokeWeight =0;

try {
myOval.fillColor=app.documents[0].swatches.item(swArray[ln]);
}
catch (e) {
ln4=Number (ln2)+1;
app.documents[0].colors.add({name:"gColor"+ln4, model:ColorModel.process,space:ColorSpace.cmyk,colorValue:[0, 0, 0, 20]});
myOval.fillColor= app.documents[0].swatches.itemByName("gColor"+ln4);
}

Sct=app.activeDocument.layers.itemByName(gphName).pageItems[i].intersectPath( app.activeDocument.layers.itemByName(gphName).pageItems[0]); //交差 
Sct.name="S-"+ln;
Sct.sendToBack();
}
//……………………………………………………
ruiseki=ruiseki+perNum;
gCount =gCount+1;

if(ruiseki>100){
alert("合計が100を超えています!\r正しく作図できていません。");
myOval = app.activeDocument.ovals.add();//楕円
myOval.geometricBounds = [y1o,x1o,y2o,x2o];//[y1,x1,y2,x2]の順
myOval.move(app.documents[0].layers.itemByName(gphName));
myOval.strokeWeight =0;
app.documents[0].colors.add({name:"gColorNG", model:ColorModel.process,space:ColorSpace.cmyk,colorValue:[0, 100, 0, 0]});
myOval.fillColor= app.documents[0].swatches.itemByName("gColorNG");
exit();
};
};

if(ruiseki<100){

//baseRectの作図
baseRect1 = app.activeDocument.rectangles.add();//長方形1
baseRect1.geometricBounds = [y1r,x1r,y2r,x2r];//[y1,x1,y2,x2]の順
baseRect1.move(app.documents[0].layers.itemByName(gphName));
baseRect1.fillColor="None";
baseRect1.strokeColor="None";

baseRect2 = app.activeDocument.rectangles.add();//長方形2
baseRect2.geometricBounds = [y1r,x1r,y2r,x2r];//[y1,x1,y2,x2]の順
baseRect2.move(app.documents[0].layers.itemByName(gphName));
baseRect2.fillColor="None";
baseRect2.strokeColor="None";

basePer=ruiseki; 


if(basePer<50){
    var baseDig = -360*basePer/100;　//ここまでの回転角度
    var my_matrix = app.transformationMatrices.add({counterclockwiseRotationAngle:baseDig});
    baseRect2.transform (CoordinateSpaces.PASTEBOARD_COORDINATES, AnchorPoint.LEFT_CENTER_ANCHOR, my_matrix);
    app.activeDocument.layers.itemByName(gphName).pageItems[gCount-1].subtractPath( app.activeDocument.layers.itemByName(gphName).pageItems[gCount]); //前面オブジェクトで型抜き
    }else{
    var baseDig = -360*(basePer-50)/100;　//ここまでの回転角度−180度（50%）
    var my_matrix = app.transformationMatrices.add({counterclockwiseRotationAngle:baseDig});
    baseRect2.transform (CoordinateSpaces.PASTEBOARD_COORDINATES, AnchorPoint.LEFT_CENTER_ANCHOR, my_matrix);
    app.activeDocument.layers.itemByName(gphName).pageItems[gCount-1].addPath( app.activeDocument.layers.itemByName(gphName).pageItems[gCount]); //結合
}
myOval = app.activeDocument.ovals.add();//楕円
myOval.geometricBounds = [y1o,x1o,y2o,x2o];//[y1,x1,y2,x2]の順
myOval.move(app.documents[0].layers.itemByName(gphName));
myOval.strokeWeight =0;
myOval.fillColor=app.documents[0].swatches.item(sRemColor);

SctRem=app.activeDocument.layers.itemByName(gphName).pageItems[gCount].subtractPath( app.activeDocument.layers.itemByName(gphName).pageItems[0]); 
SctRem.name="S-rem";
SctRem.sendToBack();

}

//空で透明のテキストフレームを削除
var pageObj = app.activeDocument.pages;
var mySwatch = app.activeDocument.swatches;
for (var i=0; i<pageObj.length; i++){
   for (var j=pageObj[i].textFrames.length-1; j>=0; j--){
            if(pageObj[i].textFrames[j].contents == "" && pageObj[i].textFrames[j].fillColor== mySwatch.itemByName("None") && pageObj[i].textFrames[j].strokeColor== mySwatch.itemByName("None")){
            
			pageObj[i].textFrames[j].remove();}
	}
}

//空のテキストフレームを割り当てなしに
var pageObj = app.activeDocument.pages;
for (var i=0; i<pageObj.length; i++){
   for (var j=pageObj[i].textFrames.length-1; j>=0; j--){
		if(pageObj[i].textFrames[j].contents == ""){
			pageObj[i].textFrames[j].contentType = ContentType.unassigned;}
	}
}